/**
 * This program is free software, you can redistribute it and/or
 * modify it under the terms of the GNU General Public License, a copy
 * of which is provided under the name LICENSE.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Copyright 2004 Robert Osada
 * $Id: Seq.cpp,v 1.28 2004/07/29 15:41:19 rosada Exp $
 **/
#include <ctype.h>
#include "Seq.h"

Seq::Seq () :
  desc(0), sid(0), pid(0), seq(0),
  len(0)
{}

void Seq::clear () {
  strFree(desc);
  strFree(sid );
  strFree(pid );
  strFree(seq );
  len = 0;
  clearSites();
}

// find site (all caps) in the sequence
int Seq::findSites () {
  int before = sites.size();
  int loc = 0;
  while (loc < len) {
    // find start
    while (loc < len) {
      if (isupper(seq[loc]))
	break;
      loc++;
    }
    if (loc < len) {
      // find one-past end
      int end = loc + 1;
      while (end < len) {
	if (islower(seq[end]))
	  break;
	end++;
      }
      int siteLen = end - loc;
      sites.push_back(new Site(sid, seq, loc, true, siteLen, 0));
      loc = end;
    }
  }
  return sites.size() - before;
}

void Seq::clearSites () {
  deleteVec(sites);
}
