/**
 * This program is free software, you can redistribute it and/or
 * modify it under the terms of the GNU General Public License, a copy
 * of which is provided under the name LICENSE.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Copyright 2004 Robert Osada
 * $Id: Seq.h,v 1.32 2004/07/29 20:58:47 rosada Exp $
 **/
#ifndef __SEQ_H__
#define __SEQ_H__

#include "DNA.h"
#include "Site.h"

struct Seq
{
  cstring desc, sid, pid, seq;
  int     len;
  Sites   sites;

  Seq ();
 ~Seq () { clear(); }
  void clear ();

  int  findSites  ();
  void clearSites ();

  bool isDNA   () { return ::isDNA  (seq, len); }
  bool isRComp () { return ::isRComp(seq, len); }

  char& operator [] (int i) { assert(i>=0 && i<len); return seq[i]; }
};
typedef         Seq      *SeqPtr;
typedef vector< SeqPtr >  Seqs;
typedef         Seqs     *SeqsPtr;
typedef vector< SeqsPtr > SeqsVec;

#endif
