/**
 * This program is free software, you can redistribute it and/or
 * modify it under the terms of the GNU General Public License, a copy
 * of which is provided under the name LICENSE.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Copyright 2004 Robert Osada
 * $Id: SiteScorer.h,v 1.8 2004/06/02 17:03:18 rosada Exp $
 *
 * Score a site using only single columns.
 **/
#ifndef __SITE_SCORER_H__
#define __SITE_SCORER_H__

#include "Site.h"
#include "DNAFreq.h"

struct SiteScorer {
  FreqType  ft;
  ScoreType st;
  int       len, len1;
  DNAFreq   obg;

  int      size;
  DNAFreq  bg;
  DNAFreqs col;
  double   totalIc;

  SiteScorer (FreqType ft, ScoreType st, int len, DNAFreq &obg);
  virtual ~SiteScorer () {}
  virtual void clear ();
  
  virtual
  void add (cstring seq  , bool pStrand=true, int weight=1);
  void add (SitePtr s    , int weight=1);
  void add (Sites  &sites, int weight=1);

  virtual void update ();
  void update (DNAFreq &f, DNAFreq &bg);

  virtual double operator() (cstring seq, bool pStrand);

  virtual void expectedScore (DNAFreq &r, double &mu, double &var);
};
typedef SiteScorer *SiteScorerPtr;

struct CentroidScorer : public SiteScorer {
  CentroidScorer (int len, DNAFreq &obg);
  double operator() (cstring seq, bool pStrand);
};

#endif
