/**
 * This program is free software, you can redistribute it and/or
 * modify it under the terms of the GNU General Public License, a copy
 * of which is provided under the name LICENSE.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Copyright 2004 Robert Osada
 * $Id: DNA.cpp,v 1.4 2004/06/02 17:05:27 rosada Exp $
 **/
#include "DNA.h"

bool isDNA (cstring s, int len) {
  assert(s);
  for (int i=0; i<len; i++)
    if (!isDNA(*s++))
      return false;
  return true;
}

bool isRComp (cstring s, int len) {
  assert(s);
  cstring t = s + len - 1;
  int half = len / 2;
  for (int i=0; i<half; i++)
    if (baseIndex(*s++) != compIndex(*t--))
      return false;
  return true;
}

int hammingDist (cstring s, cstring t, bool pStrand, int len) {
  assert(s && t);
  int count = 0;
  if (pStrand) {
    for (int i=0; i<len; i++)
      if (baseIndex(*s++) != baseIndex(*t++))
	count++;
  }
  else {
    t += len - 1;
    for (int i=0; i<len; i++)
      if (baseIndex(*s++) != compIndex(*t--))
	count++;
  }
  return count;
}
