/**
 * This program is free software, you can redistribute it and/or
 * modify it under the terms of the GNU General Public License, a copy
 * of which is provided under the name LICENSE.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Copyright 2004 Robert Osada
 * $Id: Fasta.h,v 1.15 2004/07/29 05:10:22 rosada Exp $
 *
 * Read and write FASTA files.
 **/
#ifndef __FASTA_H__
#define __FASTA_H__

#include "Seq.h"

bool getNextSeq   (FILE *file, Seq &seq, bool findSites=false);
int  readSeqs     (cstring fileName, Seqs    &seqs,  bool findSites=false);
int  readProteins (cstring fileName, SeqsVec &prots, bool findSites=false);

bool writeSeq (FILE *file, cstring desc, cstring seq, int len, int wrap=60);
bool writeSeq (FILE *file, Seq  &seq , int wrap=60);
bool writeSeq (FILE *file, Site &site, int wrap=60);

#endif
